#include <stdio.h>
#include <liblustre.h>
#include <linux/lustre_lib.h>
#include <linux/lustre_idl.h>

#undef LASSERT
#undef LASSERTF
#define LASSERT(cond) if (!(cond)) { printf("failed " #cond "\n"); ret = 1; }
#define LASSERTF(cond, fmt, arg) if (!(cond)) { printf("failed '" #cond "'" fmt, arg);ret = 1;}

int ret;

void lustre_assert_wire_constants(void);

int main()
{
	lustre_assert_wire_constants();

	if (ret == 0)
		printf("wire constants OK\n");

	return ret;
}

void lustre_assert_wire_constants(void)
{
        /* Wire protocol assertions generated by 'wirecheck'
         * running on Linux firefly.localdomain 2.6.7 #1 Wed Jun 16 10:50:27 EEST 2004 i686 i686 i386
         * with gcc version 3.3.3 20040412 (Red Hat Linux 3.3.3-7) */


        /* Constants... */
        LASSERTF(PTLRPC_MSG_MAGIC == 0x0BD00BD0," found %lld\n",
                 (long long)PTLRPC_MSG_MAGIC);
        LASSERTF(PTLRPC_MSG_VERSION == 0x00000003," found %lld\n",
                 (long long)PTLRPC_MSG_VERSION);
        LASSERTF(PTL_RPC_MSG_REQUEST == 4711, " found %lld\n",
                 (long long)PTL_RPC_MSG_REQUEST);
        LASSERTF(PTL_RPC_MSG_ERR == 4712, " found %lld\n",
                 (long long)PTL_RPC_MSG_ERR);
        LASSERTF(PTL_RPC_MSG_REPLY == 4713, " found %lld\n",
                 (long long)PTL_RPC_MSG_REPLY);
        LASSERTF(MSG_LAST_REPLAY == 1, " found %lld\n",
                 (long long)MSG_LAST_REPLAY);
        LASSERTF(MSG_RESENT == 2, " found %lld\n",
                 (long long)MSG_RESENT);
        LASSERTF(MSG_REPLAY == 4, " found %lld\n",
                 (long long)MSG_REPLAY);
        LASSERTF(MSG_CONNECT_RECOVERING == 1, " found %lld\n",
                 (long long)MSG_CONNECT_RECOVERING);
        LASSERTF(MSG_CONNECT_RECONNECT == 2, " found %lld\n",
                 (long long)MSG_CONNECT_RECONNECT);
        LASSERTF(MSG_CONNECT_REPLAYABLE == 4, " found %lld\n",
                 (long long)MSG_CONNECT_REPLAYABLE);
        LASSERTF(OST_REPLY == 0, " found %lld\n",
                 (long long)OST_REPLY);
        LASSERTF(OST_GETATTR == 1, " found %lld\n",
                 (long long)OST_GETATTR);
        LASSERTF(OST_SETATTR == 2, " found %lld\n",
                 (long long)OST_SETATTR);
        LASSERTF(OST_READ == 3, " found %lld\n",
                 (long long)OST_READ);
        LASSERTF(OST_WRITE == 4, " found %lld\n",
                 (long long)OST_WRITE);
        LASSERTF(OST_CREATE == 5, " found %lld\n",
                 (long long)OST_CREATE);
        LASSERTF(OST_DESTROY == 6, " found %lld\n",
                 (long long)OST_DESTROY);
        LASSERTF(OST_GET_INFO == 7, " found %lld\n",
                 (long long)OST_GET_INFO);
        LASSERTF(OST_CONNECT == 8, " found %lld\n",
                 (long long)OST_CONNECT);
        LASSERTF(OST_DISCONNECT == 9, " found %lld\n",
                 (long long)OST_DISCONNECT);
        LASSERTF(OST_PUNCH == 10, " found %lld\n",
                 (long long)OST_PUNCH);
        LASSERTF(OST_OPEN == 11, " found %lld\n",
                 (long long)OST_OPEN);
        LASSERTF(OST_CLOSE == 12, " found %lld\n",
                 (long long)OST_CLOSE);
        LASSERTF(OST_STATFS == 13, " found %lld\n",
                 (long long)OST_STATFS);
        LASSERTF(OST_SAN_READ == 14, " found %lld\n",
                 (long long)OST_SAN_READ);
        LASSERTF(OST_SAN_WRITE == 15, " found %lld\n",
                 (long long)OST_SAN_WRITE);
        LASSERTF(OST_SYNC == 16, " found %lld\n",
                 (long long)OST_SYNC);
        LASSERTF(OST_LAST_OPC == 18, " found %lld\n",
                 (long long)OST_LAST_OPC);
        LASSERTF(OBD_OBJECT_EOF == 0xffffffffffffffffULL," found %lld\n",
                 (long long)OBD_OBJECT_EOF);
        LASSERTF(OST_REQ_HAS_OA1 == 1, " found %lld\n",
                 (long long)OST_REQ_HAS_OA1);
        LASSERTF(MDS_GETATTR == 33, " found %lld\n",
                 (long long)MDS_GETATTR);
        LASSERTF(MDS_GETATTR_NAME == 34, " found %lld\n",
                 (long long)MDS_GETATTR_NAME);
        LASSERTF(MDS_CLOSE == 35, " found %lld\n",
                 (long long)MDS_CLOSE);
        LASSERTF(MDS_REINT == 36, " found %lld\n",
                 (long long)MDS_REINT);
        LASSERTF(MDS_READPAGE == 37, " found %lld\n",
                 (long long)MDS_READPAGE);
        LASSERTF(MDS_CONNECT == 38, " found %lld\n",
                 (long long)MDS_CONNECT);
        LASSERTF(MDS_DISCONNECT == 39, " found %lld\n",
                 (long long)MDS_DISCONNECT);
        LASSERTF(MDS_GETSTATUS == 40, " found %lld\n",
                 (long long)MDS_GETSTATUS);
        LASSERTF(MDS_STATFS == 41, " found %lld\n",
                 (long long)MDS_STATFS);
        LASSERTF(MDS_PIN == 42, " found %lld\n",
                 (long long)MDS_PIN);
        LASSERTF(MDS_UNPIN == 43, " found %lld\n",
                 (long long)MDS_UNPIN);
        LASSERTF(MDS_SYNC == 44, " found %lld\n",
                 (long long)MDS_SYNC);
        LASSERTF(MDS_DONE_WRITING == 45, " found %lld\n",
                 (long long)MDS_DONE_WRITING);
        LASSERTF(MDS_LAST_OPC == 46, " found %lld\n",
                 (long long)MDS_LAST_OPC);
        LASSERTF(REINT_SETATTR == 1, " found %lld\n",
                 (long long)REINT_SETATTR);
        LASSERTF(REINT_CREATE == 2, " found %lld\n",
                 (long long)REINT_CREATE);
        LASSERTF(REINT_LINK == 3, " found %lld\n",
                 (long long)REINT_LINK);
        LASSERTF(REINT_UNLINK == 4, " found %lld\n",
                 (long long)REINT_UNLINK);
        LASSERTF(REINT_RENAME == 5, " found %lld\n",
                 (long long)REINT_RENAME);
        LASSERTF(REINT_OPEN == 6, " found %lld\n",
                 (long long)REINT_OPEN);
        LASSERTF(REINT_MAX == 8, " found %lld\n",
                 (long long)REINT_MAX);
        LASSERTF(DISP_IT_EXECD == 1, " found %lld\n",
                 (long long)DISP_IT_EXECD);
        LASSERTF(DISP_LOOKUP_EXECD == 2, " found %lld\n",
                 (long long)DISP_LOOKUP_EXECD);
        LASSERTF(DISP_LOOKUP_NEG == 4, " found %lld\n",
                 (long long)DISP_LOOKUP_NEG);
        LASSERTF(DISP_LOOKUP_POS == 8, " found %lld\n",
                 (long long)DISP_LOOKUP_POS);
        LASSERTF(DISP_OPEN_CREATE == 16, " found %lld\n",
                 (long long)DISP_OPEN_CREATE);
        LASSERTF(DISP_OPEN_OPEN == 32, " found %lld\n",
                 (long long)DISP_OPEN_OPEN);
        LASSERTF(MDS_STATUS_CONN == 1, " found %lld\n",
                 (long long)MDS_STATUS_CONN);
        LASSERTF(MDS_STATUS_LOV == 2, " found %lld\n",
                 (long long)MDS_STATUS_LOV);
        LASSERTF(MDS_OPEN_HAS_EA == 1073741824, " found %lld\n",
                 (long long)MDS_OPEN_HAS_EA);
        LASSERTF(LDLM_ENQUEUE == 101, " found %lld\n",
                 (long long)LDLM_ENQUEUE);
        LASSERTF(LDLM_CONVERT == 102, " found %lld\n",
                 (long long)LDLM_CONVERT);
        LASSERTF(LDLM_CANCEL == 103, " found %lld\n",
                 (long long)LDLM_CANCEL);
        LASSERTF(LDLM_BL_CALLBACK == 104, " found %lld\n",
                 (long long)LDLM_BL_CALLBACK);
        LASSERTF(LDLM_CP_CALLBACK == 105, " found %lld\n",
                 (long long)LDLM_CP_CALLBACK);
        LASSERTF(LDLM_LAST_OPC == 107, " found %lld\n",
                 (long long)LDLM_LAST_OPC);
        LASSERTF(LCK_EX == 1, " found %lld\n",
                 (long long)LCK_EX);
        LASSERTF(LCK_PW == 2, " found %lld\n",
                 (long long)LCK_PW);
        LASSERTF(LCK_PR == 4, " found %lld\n",
                 (long long)LCK_PR);
        LASSERTF(LCK_CW == 8, " found %lld\n",
                 (long long)LCK_CW);
        LASSERTF(LCK_CR == 16, " found %lld\n",
                 (long long)LCK_CR);
        LASSERTF(LCK_NL == 32, " found %lld\n",
                 (long long)LCK_NL);
        LASSERTF(PTLBD_QUERY == 200, " found %lld\n",
                 (long long)PTLBD_QUERY);
        LASSERTF(PTLBD_READ == 201, " found %lld\n",
                 (long long)PTLBD_READ);
        LASSERTF(PTLBD_WRITE == 202, " found %lld\n",
                 (long long)PTLBD_WRITE);
        LASSERTF(PTLBD_FLUSH == 203, " found %lld\n",
                 (long long)PTLBD_FLUSH);
        LASSERTF(PTLBD_CONNECT == 204, " found %lld\n",
                 (long long)PTLBD_CONNECT);
        LASSERTF(PTLBD_DISCONNECT == 205, " found %lld\n",
                 (long long)PTLBD_DISCONNECT);
        LASSERTF(PTLBD_LAST_OPC == 206, " found %lld\n",
                 (long long)PTLBD_LAST_OPC);
        LASSERTF(MGMT_CONNECT == 250, " found %lld\n",
                 (long long)MGMT_CONNECT);
        LASSERTF(MGMT_DISCONNECT == 251, " found %lld\n",
                 (long long)MGMT_DISCONNECT);
        LASSERTF(MGMT_EXCEPTION == 252, " found %lld\n",
                 (long long)MGMT_EXCEPTION);
        LASSERTF(OBD_PING == 400, " found %lld\n",
                 (long long)OBD_PING);
        LASSERTF(OBD_LOG_CANCEL == 401, " found %lld\n",
                 (long long)OBD_LOG_CANCEL);
        LASSERTF(OBD_LAST_OPC == 402, " found %lld\n",
                 (long long)OBD_LAST_OPC);
        /* Sizes and Offsets */


        /* Checks for struct lustre_handle */
        LASSERTF((int)sizeof(struct lustre_handle) == 8, " found %lld\n",
                 (long long)(int)sizeof(struct lustre_handle));
        LASSERTF((int)offsetof(struct lustre_handle, cookie) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_handle, cookie));
        LASSERTF((int)sizeof(((struct lustre_handle *)0)->cookie) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_handle *)0)->cookie));

        /* Checks for struct lustre_msg */
        LASSERTF((int)sizeof(struct lustre_msg) == 64, " found %lld\n",
                 (long long)(int)sizeof(struct lustre_msg));
        LASSERTF((int)offsetof(struct lustre_msg, handle) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, handle));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->handle) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->handle));
        LASSERTF((int)offsetof(struct lustre_msg, magic) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, magic));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->magic) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->magic));
        LASSERTF((int)offsetof(struct lustre_msg, type) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, type));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->type) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->type));
        LASSERTF((int)offsetof(struct lustre_msg, version) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, version));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->version) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->version));
        LASSERTF((int)offsetof(struct lustre_msg, opc) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, opc));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->opc) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->opc));
        LASSERTF((int)offsetof(struct lustre_msg, last_xid) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, last_xid));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->last_xid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->last_xid));
        LASSERTF((int)offsetof(struct lustre_msg, last_committed) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, last_committed));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->last_committed) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->last_committed));
        LASSERTF((int)offsetof(struct lustre_msg, transno) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, transno));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->transno) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->transno));
        LASSERTF((int)offsetof(struct lustre_msg, status) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, status));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->status) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->status));
        LASSERTF((int)offsetof(struct lustre_msg, flags) == 52, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, flags));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->flags));
        LASSERTF((int)offsetof(struct lustre_msg, bufcount) == 60, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, bufcount));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->bufcount) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->bufcount));
        LASSERTF((int)offsetof(struct lustre_msg, buflens[7]) == 92, " found %lld\n",
                 (long long)(int)offsetof(struct lustre_msg, buflens[7]));
        LASSERTF((int)sizeof(((struct lustre_msg *)0)->buflens[7]) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lustre_msg *)0)->buflens[7]));

        /* Checks for struct obdo */
        LASSERTF((int)sizeof(struct obdo) == 172, " found %lld\n",
                 (long long)(int)sizeof(struct obdo));
        LASSERTF((int)offsetof(struct obdo, o_id) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_id));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_id) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_id));
        LASSERTF((int)offsetof(struct obdo, o_gr) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_gr));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_gr) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_gr));
        LASSERTF((int)offsetof(struct obdo, o_atime) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_atime));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_atime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_atime));
        LASSERTF((int)offsetof(struct obdo, o_mtime) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_mtime));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_mtime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_mtime));
        LASSERTF((int)offsetof(struct obdo, o_ctime) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_ctime));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_ctime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_ctime));
        LASSERTF((int)offsetof(struct obdo, o_size) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_size));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_size) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_size));
        LASSERTF((int)offsetof(struct obdo, o_blocks) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_blocks));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_blocks) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_blocks));
        LASSERTF((int)offsetof(struct obdo, o_grant) == 56, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_grant));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_grant) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_grant));
        LASSERTF((int)offsetof(struct obdo, o_blksize) == 64, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_blksize));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_blksize) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_blksize));
        LASSERTF((int)offsetof(struct obdo, o_mode) == 68, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_mode));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_mode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_mode));
        LASSERTF((int)offsetof(struct obdo, o_uid) == 72, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_uid));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_uid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_uid));
        LASSERTF((int)offsetof(struct obdo, o_gid) == 76, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_gid));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_gid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_gid));
        LASSERTF((int)offsetof(struct obdo, o_flags) == 80, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_flags));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_flags));
        LASSERTF((int)offsetof(struct obdo, o_nlink) == 84, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_nlink));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_nlink) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_nlink));
        LASSERTF((int)offsetof(struct obdo, o_generation) == 88, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_generation));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_generation) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_generation));
        LASSERTF((int)offsetof(struct obdo, o_valid) == 92, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_valid));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_valid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_valid));
        LASSERTF((int)offsetof(struct obdo, o_misc) == 96, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_misc));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_misc) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_misc));
        LASSERTF((int)offsetof(struct obdo, o_easize) == 100, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_easize));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_easize) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_easize));
        LASSERTF((int)offsetof(struct obdo, o_inline) == 108, " found %lld\n",
                 (long long)(int)offsetof(struct obdo, o_inline));
        LASSERTF((int)sizeof(((struct obdo *)0)->o_inline) == 64, " found %lld\n",
                 (long long)(int)sizeof(((struct obdo *)0)->o_inline));
        LASSERTF(OBD_MD_FLID == 1, " found %lld\n",
                 (long long)OBD_MD_FLID);
        LASSERTF(OBD_MD_FLATIME == 2, " found %lld\n",
                 (long long)OBD_MD_FLATIME);
        LASSERTF(OBD_MD_FLMTIME == 4, " found %lld\n",
                 (long long)OBD_MD_FLMTIME);
        LASSERTF(OBD_MD_FLCTIME == 8, " found %lld\n",
                 (long long)OBD_MD_FLCTIME);
        LASSERTF(OBD_MD_FLSIZE == 16, " found %lld\n",
                 (long long)OBD_MD_FLSIZE);
        LASSERTF(OBD_MD_FLBLOCKS == 32, " found %lld\n",
                 (long long)OBD_MD_FLBLOCKS);
        LASSERTF(OBD_MD_FLBLKSZ == 64, " found %lld\n",
                 (long long)OBD_MD_FLBLKSZ);
        LASSERTF(OBD_MD_FLMODE == 128, " found %lld\n",
                 (long long)OBD_MD_FLMODE);
        LASSERTF(OBD_MD_FLTYPE == 256, " found %lld\n",
                 (long long)OBD_MD_FLTYPE);
        LASSERTF(OBD_MD_FLUID == 512, " found %lld\n",
                 (long long)OBD_MD_FLUID);
        LASSERTF(OBD_MD_FLGID == 1024, " found %lld\n",
                 (long long)OBD_MD_FLGID);
        LASSERTF(OBD_MD_FLFLAGS == 2048, " found %lld\n",
                 (long long)OBD_MD_FLFLAGS);
        LASSERTF(OBD_MD_FLNLINK == 8192, " found %lld\n",
                 (long long)OBD_MD_FLNLINK);
        LASSERTF(OBD_MD_FLGENER == 16384, " found %lld\n",
                 (long long)OBD_MD_FLGENER);
        LASSERTF(OBD_MD_FLINLINE == 32768, " found %lld\n",
                 (long long)OBD_MD_FLINLINE);
        LASSERTF(OBD_MD_FLRDEV == 65536, " found %lld\n",
                 (long long)OBD_MD_FLRDEV);
        LASSERTF(OBD_MD_FLEASIZE == 131072, " found %lld\n",
                 (long long)OBD_MD_FLEASIZE);
        LASSERTF(OBD_MD_LINKNAME == 262144, " found %lld\n",
                 (long long)OBD_MD_LINKNAME);
        LASSERTF(OBD_MD_FLHANDLE == 524288, " found %lld\n",
                 (long long)OBD_MD_FLHANDLE);
        LASSERTF(OBD_MD_FLCKSUM == 1048576, " found %lld\n",
                 (long long)OBD_MD_FLCKSUM);
        LASSERTF(OBD_MD_FLQOS == 2097152, " found %lld\n",
                 (long long)OBD_MD_FLQOS);
        LASSERTF(OBD_MD_FLOSCOPQ == 4194304, " found %lld\n",
                 (long long)OBD_MD_FLOSCOPQ);
        LASSERTF(OBD_MD_FLCOOKIE == 8388608, " found %lld\n",
                 (long long)OBD_MD_FLCOOKIE);
        LASSERTF(OBD_MD_FLGROUP == 16777216, " found %lld\n",
                 (long long)OBD_MD_FLGROUP);
        LASSERTF(OBD_FL_INLINEDATA == 1, " found %lld\n",
                 (long long)OBD_FL_INLINEDATA);
        LASSERTF(OBD_FL_OBDMDEXISTS == 2, " found %lld\n",
                 (long long)OBD_FL_OBDMDEXISTS);
        LASSERTF(OBD_FL_DELORPHAN == 4, " found %lld\n",
                 (long long)OBD_FL_DELORPHAN);
        LASSERTF(OBD_FL_NORPC == 8, " found %lld\n",
                 (long long)OBD_FL_NORPC);
        LASSERTF(OBD_FL_IDONLY == 16, " found %lld\n",
                 (long long)OBD_FL_IDONLY);
        LASSERTF(OBD_FL_RECREATE_OBJS == 32, " found %lld\n",
                 (long long)OBD_FL_RECREATE_OBJS);

        /* Checks for struct lov_mds_md_v1 */
        LASSERTF((int)sizeof(struct lov_mds_md_v1) == 32, " found %lld\n",
                 (long long)(int)sizeof(struct lov_mds_md_v1));
        LASSERTF((int)offsetof(struct lov_mds_md_v1, lmm_magic) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct lov_mds_md_v1, lmm_magic));
        LASSERTF((int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_magic) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_magic));
        LASSERTF((int)offsetof(struct lov_mds_md_v1, lmm_pattern) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct lov_mds_md_v1, lmm_pattern));
        LASSERTF((int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_pattern) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_pattern));
        LASSERTF((int)offsetof(struct lov_mds_md_v1, lmm_object_id) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct lov_mds_md_v1, lmm_object_id));
        LASSERTF((int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_object_id) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_object_id));
        LASSERTF((int)offsetof(struct lov_mds_md_v1, lmm_object_gr) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct lov_mds_md_v1, lmm_object_gr));
        LASSERTF((int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_object_gr) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_object_gr));
        LASSERTF((int)offsetof(struct lov_mds_md_v1, lmm_stripe_size) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct lov_mds_md_v1, lmm_stripe_size));
        LASSERTF((int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_stripe_size) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_stripe_size));
        LASSERTF((int)offsetof(struct lov_mds_md_v1, lmm_stripe_count) == 28, " found %lld\n",
                 (long long)(int)offsetof(struct lov_mds_md_v1, lmm_stripe_count));
        LASSERTF((int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_stripe_count) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_stripe_count));
        LASSERTF((int)offsetof(struct lov_mds_md_v1, lmm_objects) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct lov_mds_md_v1, lmm_objects));
        LASSERTF((int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_objects) == 0, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_mds_md_v1 *)0)->lmm_objects));

        /* Checks for struct lov_ost_data_v1 */
        LASSERTF((int)sizeof(struct lov_ost_data_v1) == 24, " found %lld\n",
                 (long long)(int)sizeof(struct lov_ost_data_v1));
        LASSERTF((int)offsetof(struct lov_ost_data_v1, l_object_id) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct lov_ost_data_v1, l_object_id));
        LASSERTF((int)sizeof(((struct lov_ost_data_v1 *)0)->l_object_id) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_ost_data_v1 *)0)->l_object_id));
        LASSERTF((int)offsetof(struct lov_ost_data_v1, l_object_gr) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct lov_ost_data_v1, l_object_gr));
        LASSERTF((int)sizeof(((struct lov_ost_data_v1 *)0)->l_object_gr) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_ost_data_v1 *)0)->l_object_gr));
        LASSERTF((int)offsetof(struct lov_ost_data_v1, l_ost_gen) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct lov_ost_data_v1, l_ost_gen));
        LASSERTF((int)sizeof(((struct lov_ost_data_v1 *)0)->l_ost_gen) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_ost_data_v1 *)0)->l_ost_gen));
        LASSERTF((int)offsetof(struct lov_ost_data_v1, l_ost_idx) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct lov_ost_data_v1, l_ost_idx));
        LASSERTF((int)sizeof(((struct lov_ost_data_v1 *)0)->l_ost_idx) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_ost_data_v1 *)0)->l_ost_idx));
        LASSERTF(LOV_MAGIC_V0 == 198183888, " found %lld\n",
                 (long long)LOV_MAGIC_V0);
        LASSERTF(LOV_MAGIC_V1 == 198249424, " found %lld\n",
                 (long long)LOV_MAGIC_V1);
        LASSERTF(LOV_PATTERN_RAID0 == 1, " found %lld\n",
                 (long long)LOV_PATTERN_RAID0);
        LASSERTF(LOV_PATTERN_RAID1 == 2, " found %lld\n",
                 (long long)LOV_PATTERN_RAID1);

        /* Checks for struct obd_statfs */
        LASSERTF((int)sizeof(struct obd_statfs) == 144, " found %lld\n",
                 (long long)(int)sizeof(struct obd_statfs));
        LASSERTF((int)offsetof(struct obd_statfs, os_type) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_type));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_type) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_type));
        LASSERTF((int)offsetof(struct obd_statfs, os_blocks) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_blocks));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_blocks) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_blocks));
        LASSERTF((int)offsetof(struct obd_statfs, os_bfree) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_bfree));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_bfree) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_bfree));
        LASSERTF((int)offsetof(struct obd_statfs, os_bavail) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_bavail));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_bavail) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_bavail));
        LASSERTF((int)offsetof(struct obd_statfs, os_ffree) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_ffree));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_ffree) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_ffree));
        LASSERTF((int)offsetof(struct obd_statfs, os_fsid) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_fsid));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_fsid) == 40, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_fsid));
        LASSERTF((int)offsetof(struct obd_statfs, os_bsize) == 88, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_bsize));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_bsize) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_bsize));
        LASSERTF((int)offsetof(struct obd_statfs, os_namelen) == 92, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_namelen));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_namelen) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_namelen));
        LASSERTF((int)offsetof(struct obd_statfs, os_spare) == 104, " found %lld\n",
                 (long long)(int)offsetof(struct obd_statfs, os_spare));
        LASSERTF((int)sizeof(((struct obd_statfs *)0)->os_spare) == 40, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_statfs *)0)->os_spare));

        /* Checks for struct obd_ioobj */
        LASSERTF((int)sizeof(struct obd_ioobj) == 24, " found %lld\n",
                 (long long)(int)sizeof(struct obd_ioobj));
        LASSERTF((int)offsetof(struct obd_ioobj, ioo_id) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct obd_ioobj, ioo_id));
        LASSERTF((int)sizeof(((struct obd_ioobj *)0)->ioo_id) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_ioobj *)0)->ioo_id));
        LASSERTF((int)offsetof(struct obd_ioobj, ioo_gr) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct obd_ioobj, ioo_gr));
        LASSERTF((int)sizeof(((struct obd_ioobj *)0)->ioo_gr) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_ioobj *)0)->ioo_gr));
        LASSERTF((int)offsetof(struct obd_ioobj, ioo_type) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct obd_ioobj, ioo_type));
        LASSERTF((int)sizeof(((struct obd_ioobj *)0)->ioo_type) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_ioobj *)0)->ioo_type));
        LASSERTF((int)offsetof(struct obd_ioobj, ioo_bufcnt) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct obd_ioobj, ioo_bufcnt));
        LASSERTF((int)sizeof(((struct obd_ioobj *)0)->ioo_bufcnt) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct obd_ioobj *)0)->ioo_bufcnt));

        /* Checks for struct niobuf_remote */
        LASSERTF((int)sizeof(struct niobuf_remote) == 16, " found %lld\n",
                 (long long)(int)sizeof(struct niobuf_remote));
        LASSERTF((int)offsetof(struct niobuf_remote, offset) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct niobuf_remote, offset));
        LASSERTF((int)sizeof(((struct niobuf_remote *)0)->offset) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct niobuf_remote *)0)->offset));
        LASSERTF((int)offsetof(struct niobuf_remote, len) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct niobuf_remote, len));
        LASSERTF((int)sizeof(((struct niobuf_remote *)0)->len) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct niobuf_remote *)0)->len));
        LASSERTF((int)offsetof(struct niobuf_remote, flags) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct niobuf_remote, flags));
        LASSERTF((int)sizeof(((struct niobuf_remote *)0)->flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct niobuf_remote *)0)->flags));
        LASSERTF(OBD_BRW_READ == 1, " found %lld\n",
                 (long long)OBD_BRW_READ);
        LASSERTF(OBD_BRW_WRITE == 2, " found %lld\n",
                 (long long)OBD_BRW_WRITE);
        LASSERTF(OBD_BRW_SYNC == 8, " found %lld\n",
                 (long long)OBD_BRW_SYNC);
        LASSERTF(OBD_BRW_FROM_GRANT == 32, " found %lld\n",
                 (long long)OBD_BRW_FROM_GRANT);

        /* Checks for struct ost_body */
        LASSERTF((int)sizeof(struct ost_body) == 172, " found %lld\n",
                 (long long)(int)sizeof(struct ost_body));
        LASSERTF((int)offsetof(struct ost_body, oa) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ost_body, oa));
        LASSERTF((int)sizeof(((struct ost_body *)0)->oa) == 172, " found %lld\n",
                 (long long)(int)sizeof(((struct ost_body *)0)->oa));

        /* Checks for struct ll_fid */
        LASSERTF((int)sizeof(struct ll_fid) == 24, " found %lld\n",
                 (long long)(int)sizeof(struct ll_fid));
        LASSERTF((int)offsetof(struct ll_fid, id) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ll_fid, id));
        LASSERTF((int)sizeof(((struct ll_fid *)0)->id) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ll_fid *)0)->id));
        LASSERTF((int)offsetof(struct ll_fid, generation) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ll_fid, generation));
        LASSERTF((int)sizeof(((struct ll_fid *)0)->generation) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ll_fid *)0)->generation));
        LASSERTF((int)offsetof(struct ll_fid, f_type) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct ll_fid, f_type));
        LASSERTF((int)sizeof(((struct ll_fid *)0)->f_type) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ll_fid *)0)->f_type));

        /* Checks for struct mds_status_req */
        LASSERTF((int)sizeof(struct mds_status_req) == 8, " found %lld\n",
                 (long long)(int)sizeof(struct mds_status_req));
        LASSERTF((int)offsetof(struct mds_status_req, flags) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct mds_status_req, flags));
        LASSERTF((int)sizeof(((struct mds_status_req *)0)->flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_status_req *)0)->flags));
        LASSERTF((int)offsetof(struct mds_status_req, repbuf) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct mds_status_req, repbuf));
        LASSERTF((int)sizeof(((struct mds_status_req *)0)->repbuf) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_status_req *)0)->repbuf));

        /* Checks for struct mds_body */
        LASSERTF((int)sizeof(struct mds_body) == 152, " found %lld\n",
                 (long long)(int)sizeof(struct mds_body));
        LASSERTF((int)offsetof(struct mds_body, fid1) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, fid1));
        LASSERTF((int)sizeof(((struct mds_body *)0)->fid1) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->fid1));
        LASSERTF((int)offsetof(struct mds_body, fid2) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, fid2));
        LASSERTF((int)sizeof(((struct mds_body *)0)->fid2) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->fid2));
        LASSERTF((int)offsetof(struct mds_body, handle) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, handle));
        LASSERTF((int)sizeof(((struct mds_body *)0)->handle) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->handle));
        LASSERTF((int)offsetof(struct mds_body, size) == 56, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, size));
        LASSERTF((int)sizeof(((struct mds_body *)0)->size) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->size));
        LASSERTF((int)offsetof(struct mds_body, blocks) == 64, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, blocks));
        LASSERTF((int)sizeof(((struct mds_body *)0)->blocks) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->blocks));
        LASSERTF((int)offsetof(struct mds_body, io_epoch) == 72, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, io_epoch));
        LASSERTF((int)sizeof(((struct mds_body *)0)->io_epoch) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->io_epoch));
        LASSERTF((int)offsetof(struct mds_body, ino) == 80, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, ino));
        LASSERTF((int)sizeof(((struct mds_body *)0)->ino) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->ino));
        LASSERTF((int)offsetof(struct mds_body, valid) == 84, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, valid));
        LASSERTF((int)sizeof(((struct mds_body *)0)->valid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->valid));
        LASSERTF((int)offsetof(struct mds_body, fsuid) == 88, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, fsuid));
        LASSERTF((int)sizeof(((struct mds_body *)0)->fsuid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->fsuid));
        LASSERTF((int)offsetof(struct mds_body, fsgid) == 92, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, fsgid));
        LASSERTF((int)sizeof(((struct mds_body *)0)->fsgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->fsgid));
        LASSERTF((int)offsetof(struct mds_body, capability) == 96, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, capability));
        LASSERTF((int)sizeof(((struct mds_body *)0)->capability) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->capability));
        LASSERTF((int)offsetof(struct mds_body, mode) == 100, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, mode));
        LASSERTF((int)sizeof(((struct mds_body *)0)->mode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->mode));
        LASSERTF((int)offsetof(struct mds_body, uid) == 104, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, uid));
        LASSERTF((int)sizeof(((struct mds_body *)0)->uid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->uid));
        LASSERTF((int)offsetof(struct mds_body, gid) == 108, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, gid));
        LASSERTF((int)sizeof(((struct mds_body *)0)->gid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->gid));
        LASSERTF((int)offsetof(struct mds_body, mtime) == 112, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, mtime));
        LASSERTF((int)sizeof(((struct mds_body *)0)->mtime) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->mtime));
        LASSERTF((int)offsetof(struct mds_body, ctime) == 116, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, ctime));
        LASSERTF((int)sizeof(((struct mds_body *)0)->ctime) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->ctime));
        LASSERTF((int)offsetof(struct mds_body, atime) == 120, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, atime));
        LASSERTF((int)sizeof(((struct mds_body *)0)->atime) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->atime));
        LASSERTF((int)offsetof(struct mds_body, flags) == 124, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, flags));
        LASSERTF((int)sizeof(((struct mds_body *)0)->flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->flags));
        LASSERTF((int)offsetof(struct mds_body, rdev) == 128, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, rdev));
        LASSERTF((int)sizeof(((struct mds_body *)0)->rdev) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->rdev));
        LASSERTF((int)offsetof(struct mds_body, nlink) == 132, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, nlink));
        LASSERTF((int)sizeof(((struct mds_body *)0)->nlink) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->nlink));
        LASSERTF((int)offsetof(struct mds_body, generation) == 136, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, generation));
        LASSERTF((int)sizeof(((struct mds_body *)0)->generation) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->generation));
        LASSERTF((int)offsetof(struct mds_body, suppgid) == 140, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, suppgid));
        LASSERTF((int)sizeof(((struct mds_body *)0)->suppgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->suppgid));
        LASSERTF((int)offsetof(struct mds_body, eadatasize) == 144, " found %lld\n",
                 (long long)(int)offsetof(struct mds_body, eadatasize));
        LASSERTF((int)sizeof(((struct mds_body *)0)->eadatasize) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_body *)0)->eadatasize));
        LASSERTF(FMODE_READ == 1, " found %lld\n",
                 (long long)FMODE_READ);
        LASSERTF(FMODE_WRITE == 2, " found %lld\n",
                 (long long)FMODE_WRITE);
        LASSERTF(FMODE_EXEC == 4, " found %lld\n",
                 (long long)FMODE_EXEC);
        LASSERTF(MDS_OPEN_CREAT == 64, " found %lld\n",
                 (long long)MDS_OPEN_CREAT);
        LASSERTF(MDS_OPEN_EXCL == 128, " found %lld\n",
                 (long long)MDS_OPEN_EXCL);
        LASSERTF(MDS_OPEN_TRUNC == 512, " found %lld\n",
                 (long long)MDS_OPEN_TRUNC);
        LASSERTF(MDS_OPEN_APPEND == 1024, " found %lld\n",
                 (long long)MDS_OPEN_APPEND);
        LASSERTF(MDS_OPEN_SYNC == 4096, " found %lld\n",
                 (long long)MDS_OPEN_SYNC);
        LASSERTF(MDS_OPEN_DIRECTORY == 65536, " found %lld\n",
                 (long long)MDS_OPEN_DIRECTORY);
        LASSERTF(MDS_OPEN_DELAY_CREATE == 16777216, " found %lld\n",
                 (long long)MDS_OPEN_DELAY_CREATE);
        LASSERTF(MDS_OPEN_HAS_EA == 1073741824, " found %lld\n",
                 (long long)MDS_OPEN_HAS_EA);

        /* Checks for struct mds_rec_setattr */
        LASSERTF((int)sizeof(struct mds_rec_setattr) == 96, " found %lld\n",
                 (long long)(int)sizeof(struct mds_rec_setattr));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_opcode) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_opcode));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_opcode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_opcode));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_fsuid) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_fsuid));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_fsuid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_fsuid));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_fsgid) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_fsgid));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_fsgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_fsgid));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_cap) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_cap));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_cap) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_cap));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_suppgid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_suppgid));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_suppgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_suppgid));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_valid) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_valid));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_valid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_valid));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_fid) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_fid));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_fid) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_fid));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_mode) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_mode));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_mode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_mode));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_uid) == 52, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_uid));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_uid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_uid));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_gid) == 56, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_gid));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_gid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_gid));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_attr_flags) == 60, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_attr_flags));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_attr_flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_attr_flags));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_size) == 64, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_size));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_size) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_size));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_atime) == 72, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_atime));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_atime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_atime));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_mtime) == 80, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_mtime));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_mtime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_mtime));
        LASSERTF((int)offsetof(struct mds_rec_setattr, sa_ctime) == 88, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_setattr, sa_ctime));
        LASSERTF((int)sizeof(((struct mds_rec_setattr *)0)->sa_ctime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_setattr *)0)->sa_ctime));

        /* Checks for struct mds_rec_create */
        LASSERTF((int)sizeof(struct mds_rec_create) == 96, " found %lld\n",
                 (long long)(int)sizeof(struct mds_rec_create));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_opcode) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_opcode));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_opcode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_opcode));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_fsuid) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_fsuid));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_fsuid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_fsuid));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_fsgid) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_fsgid));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_fsgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_fsgid));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_cap) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_cap));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_cap) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_cap));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_flags) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_flags));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_flags));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_mode) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_mode));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_mode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_mode));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_fid) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_fid));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_fid) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_fid));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_replayfid) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_replayfid));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_replayfid) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_replayfid));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_time) == 72, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_time));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_time) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_time));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_rdev) == 80, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_rdev));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_rdev) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_rdev));
        LASSERTF((int)offsetof(struct mds_rec_create, cr_suppgid) == 88, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_create, cr_suppgid));
        LASSERTF((int)sizeof(((struct mds_rec_create *)0)->cr_suppgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_create *)0)->cr_suppgid));

        /* Checks for struct mds_rec_link */
        LASSERTF((int)sizeof(struct mds_rec_link) == 80, " found %lld\n",
                 (long long)(int)sizeof(struct mds_rec_link));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_opcode) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_opcode));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_opcode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_opcode));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_fsuid) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_fsuid));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_fsuid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_fsuid));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_fsgid) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_fsgid));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_fsgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_fsgid));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_cap) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_cap));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_cap) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_cap));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_suppgid1) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_suppgid1));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_suppgid1) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_suppgid1));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_suppgid2) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_suppgid2));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_suppgid2) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_suppgid2));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_fid1) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_fid1));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_fid1) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_fid1));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_fid2) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_fid2));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_fid2) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_fid2));
        LASSERTF((int)offsetof(struct mds_rec_link, lk_time) == 72, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_link, lk_time));
        LASSERTF((int)sizeof(((struct mds_rec_link *)0)->lk_time) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_link *)0)->lk_time));

        /* Checks for struct mds_rec_unlink */
        LASSERTF((int)sizeof(struct mds_rec_unlink) == 80, " found %lld\n",
                 (long long)(int)sizeof(struct mds_rec_unlink));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_opcode) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_opcode));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_opcode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_opcode));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_fsuid) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_fsuid));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_fsuid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_fsuid));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_fsgid) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_fsgid));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_fsgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_fsgid));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_cap) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_cap));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_cap) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_cap));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_suppgid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_suppgid));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_suppgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_suppgid));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_mode) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_mode));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_mode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_mode));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_fid1) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_fid1));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_fid1) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_fid1));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_fid2) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_fid2));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_fid2) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_fid2));
        LASSERTF((int)offsetof(struct mds_rec_unlink, ul_time) == 72, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_unlink, ul_time));
        LASSERTF((int)sizeof(((struct mds_rec_unlink *)0)->ul_time) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_unlink *)0)->ul_time));

        /* Checks for struct mds_rec_rename */
        LASSERTF((int)sizeof(struct mds_rec_rename) == 80, " found %lld\n",
                 (long long)(int)sizeof(struct mds_rec_rename));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_opcode) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_opcode));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_opcode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_opcode));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_fsuid) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_fsuid));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_fsuid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_fsuid));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_fsgid) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_fsgid));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_fsgid) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_fsgid));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_cap) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_cap));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_cap) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_cap));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_suppgid1) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_suppgid1));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_suppgid1) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_suppgid1));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_suppgid2) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_suppgid2));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_suppgid2) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_suppgid2));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_fid1) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_fid1));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_fid1) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_fid1));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_fid2) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_fid2));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_fid2) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_fid2));
        LASSERTF((int)offsetof(struct mds_rec_rename, rn_time) == 72, " found %lld\n",
                 (long long)(int)offsetof(struct mds_rec_rename, rn_time));
        LASSERTF((int)sizeof(((struct mds_rec_rename *)0)->rn_time) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct mds_rec_rename *)0)->rn_time));

        /* Checks for struct lov_desc */
        LASSERTF((int)sizeof(struct lov_desc) == 72, " found %lld\n",
                 (long long)(int)sizeof(struct lov_desc));
        LASSERTF((int)offsetof(struct lov_desc, ld_tgt_count) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct lov_desc, ld_tgt_count));
        LASSERTF((int)sizeof(((struct lov_desc *)0)->ld_tgt_count) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_desc *)0)->ld_tgt_count));
        LASSERTF((int)offsetof(struct lov_desc, ld_active_tgt_count) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct lov_desc, ld_active_tgt_count));
        LASSERTF((int)sizeof(((struct lov_desc *)0)->ld_active_tgt_count) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_desc *)0)->ld_active_tgt_count));
        LASSERTF((int)offsetof(struct lov_desc, ld_default_stripe_count) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct lov_desc, ld_default_stripe_count));
        LASSERTF((int)sizeof(((struct lov_desc *)0)->ld_default_stripe_count) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_desc *)0)->ld_default_stripe_count));
        LASSERTF((int)offsetof(struct lov_desc, ld_pattern) == 12, " found %lld\n",
                 (long long)(int)offsetof(struct lov_desc, ld_pattern));
        LASSERTF((int)sizeof(((struct lov_desc *)0)->ld_pattern) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_desc *)0)->ld_pattern));
        LASSERTF((int)offsetof(struct lov_desc, ld_default_stripe_size) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct lov_desc, ld_default_stripe_size));
        LASSERTF((int)sizeof(((struct lov_desc *)0)->ld_default_stripe_size) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_desc *)0)->ld_default_stripe_size));
        LASSERTF((int)offsetof(struct lov_desc, ld_default_stripe_offset) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct lov_desc, ld_default_stripe_offset));
        LASSERTF((int)sizeof(((struct lov_desc *)0)->ld_default_stripe_offset) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_desc *)0)->ld_default_stripe_offset));
        LASSERTF((int)offsetof(struct lov_desc, ld_uuid) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct lov_desc, ld_uuid));
        LASSERTF((int)sizeof(((struct lov_desc *)0)->ld_uuid) == 40, " found %lld\n",
                 (long long)(int)sizeof(((struct lov_desc *)0)->ld_uuid));

        /* Checks for struct ldlm_res_id */
        LASSERTF((int)sizeof(struct ldlm_res_id) == 32, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_res_id));
        LASSERTF((int)offsetof(struct ldlm_res_id, name[4]) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_res_id, name[4]));
        LASSERTF((int)sizeof(((struct ldlm_res_id *)0)->name[4]) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_res_id *)0)->name[4]));

        /* Checks for struct ldlm_extent */
        LASSERTF((int)sizeof(struct ldlm_extent) == 24, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_extent));
        LASSERTF((int)offsetof(struct ldlm_extent, start) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_extent, start));
        LASSERTF((int)sizeof(((struct ldlm_extent *)0)->start) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_extent *)0)->start));
        LASSERTF((int)offsetof(struct ldlm_extent, end) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_extent, end));
        LASSERTF((int)sizeof(((struct ldlm_extent *)0)->end) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_extent *)0)->end));
        LASSERTF((int)offsetof(struct ldlm_extent, gid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_extent, gid));
        LASSERTF((int)sizeof(((struct ldlm_extent *)0)->gid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_extent *)0)->gid));

        /* Checks for struct ldlm_flock */
        LASSERTF((int)sizeof(struct ldlm_flock) == 40, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_flock));
        LASSERTF((int)offsetof(struct ldlm_flock, start) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_flock, start));
        LASSERTF((int)sizeof(((struct ldlm_flock *)0)->start) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_flock *)0)->start));
        LASSERTF((int)offsetof(struct ldlm_flock, end) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_flock, end));
        LASSERTF((int)sizeof(((struct ldlm_flock *)0)->end) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_flock *)0)->end));
        LASSERTF((int)offsetof(struct ldlm_flock, pid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_flock, pid));
        LASSERTF((int)sizeof(((struct ldlm_flock *)0)->pid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_flock *)0)->pid));
        LASSERTF((int)offsetof(struct ldlm_flock, blocking_pid) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_flock, blocking_pid));
        LASSERTF((int)sizeof(((struct ldlm_flock *)0)->blocking_pid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_flock *)0)->blocking_pid));
        LASSERTF((int)offsetof(struct ldlm_flock, blocking_export) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_flock, blocking_export));
        LASSERTF((int)sizeof(((struct ldlm_flock *)0)->blocking_export) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_flock *)0)->blocking_export));

        /* Checks for struct ldlm_intent */
        LASSERTF((int)sizeof(struct ldlm_intent) == 8, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_intent));
        LASSERTF((int)offsetof(struct ldlm_intent, opc) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_intent, opc));
        LASSERTF((int)sizeof(((struct ldlm_intent *)0)->opc) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_intent *)0)->opc));

        /* Checks for struct ldlm_resource_desc */
        LASSERTF((int)sizeof(struct ldlm_resource_desc) == 40, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_resource_desc));
        LASSERTF((int)offsetof(struct ldlm_resource_desc, lr_type) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_resource_desc, lr_type));
        LASSERTF((int)sizeof(((struct ldlm_resource_desc *)0)->lr_type) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_resource_desc *)0)->lr_type));
        LASSERTF((int)offsetof(struct ldlm_resource_desc, lr_name) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_resource_desc, lr_name));
        LASSERTF((int)sizeof(((struct ldlm_resource_desc *)0)->lr_name) == 32, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_resource_desc *)0)->lr_name));

        /* Checks for struct ldlm_lock_desc */
        LASSERTF((int)sizeof(struct ldlm_lock_desc) == 88, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_lock_desc));
        LASSERTF((int)offsetof(struct ldlm_lock_desc, l_resource) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_lock_desc, l_resource));
        LASSERTF((int)sizeof(((struct ldlm_lock_desc *)0)->l_resource) == 40, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_lock_desc *)0)->l_resource));
        LASSERTF((int)offsetof(struct ldlm_lock_desc, l_req_mode) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_lock_desc, l_req_mode));
        LASSERTF((int)sizeof(((struct ldlm_lock_desc *)0)->l_req_mode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_lock_desc *)0)->l_req_mode));
        LASSERTF((int)offsetof(struct ldlm_lock_desc, l_granted_mode) == 44, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_lock_desc, l_granted_mode));
        LASSERTF((int)sizeof(((struct ldlm_lock_desc *)0)->l_granted_mode) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_lock_desc *)0)->l_granted_mode));
        LASSERTF((int)offsetof(struct ldlm_lock_desc, l_policy_data) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_lock_desc, l_policy_data));
        LASSERTF((int)sizeof(((struct ldlm_lock_desc *)0)->l_policy_data) == 40, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_lock_desc *)0)->l_policy_data));

        /* Checks for struct ldlm_request */
        LASSERTF((int)sizeof(struct ldlm_request) == 112, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_request));
        LASSERTF((int)offsetof(struct ldlm_request, lock_flags) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_request, lock_flags));
        LASSERTF((int)sizeof(((struct ldlm_request *)0)->lock_flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_request *)0)->lock_flags));
        LASSERTF((int)offsetof(struct ldlm_request, lock_desc) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_request, lock_desc));
        LASSERTF((int)sizeof(((struct ldlm_request *)0)->lock_desc) == 88, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_request *)0)->lock_desc));
        LASSERTF((int)offsetof(struct ldlm_request, lock_handle1) == 96, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_request, lock_handle1));
        LASSERTF((int)sizeof(((struct ldlm_request *)0)->lock_handle1) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_request *)0)->lock_handle1));
        LASSERTF((int)offsetof(struct ldlm_request, lock_handle2) == 104, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_request, lock_handle2));
        LASSERTF((int)sizeof(((struct ldlm_request *)0)->lock_handle2) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_request *)0)->lock_handle2));

        /* Checks for struct ldlm_reply */
        LASSERTF((int)sizeof(struct ldlm_reply) == 120, " found %lld\n",
                 (long long)(int)sizeof(struct ldlm_reply));
        LASSERTF((int)offsetof(struct ldlm_reply, lock_flags) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_reply, lock_flags));
        LASSERTF((int)sizeof(((struct ldlm_reply *)0)->lock_flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_reply *)0)->lock_flags));
        LASSERTF((int)offsetof(struct ldlm_request, lock_desc) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_request, lock_desc));
        LASSERTF((int)sizeof(((struct ldlm_request *)0)->lock_desc) == 88, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_request *)0)->lock_desc));
        LASSERTF((int)offsetof(struct ldlm_reply, lock_handle) == 96, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_reply, lock_handle));
        LASSERTF((int)sizeof(((struct ldlm_reply *)0)->lock_handle) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_reply *)0)->lock_handle));
        LASSERTF((int)offsetof(struct ldlm_reply, lock_policy_res1) == 104, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_reply, lock_policy_res1));
        LASSERTF((int)sizeof(((struct ldlm_reply *)0)->lock_policy_res1) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_reply *)0)->lock_policy_res1));
        LASSERTF((int)offsetof(struct ldlm_reply, lock_policy_res2) == 112, " found %lld\n",
                 (long long)(int)offsetof(struct ldlm_reply, lock_policy_res2));
        LASSERTF((int)sizeof(((struct ldlm_reply *)0)->lock_policy_res2) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ldlm_reply *)0)->lock_policy_res2));

        /* Checks for struct ost_lvb */
        LASSERTF((int)sizeof(struct ost_lvb) == 40, " found %lld\n",
                 (long long)(int)sizeof(struct ost_lvb));
        LASSERTF((int)offsetof(struct ost_lvb, lvb_size) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ost_lvb, lvb_size));
        LASSERTF((int)sizeof(((struct ost_lvb *)0)->lvb_size) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ost_lvb *)0)->lvb_size));
        LASSERTF((int)offsetof(struct ost_lvb, lvb_mtime) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ost_lvb, lvb_mtime));
        LASSERTF((int)sizeof(((struct ost_lvb *)0)->lvb_mtime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ost_lvb *)0)->lvb_mtime));
        LASSERTF((int)offsetof(struct ost_lvb, lvb_atime) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct ost_lvb, lvb_atime));
        LASSERTF((int)sizeof(((struct ost_lvb *)0)->lvb_atime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ost_lvb *)0)->lvb_atime));
        LASSERTF((int)offsetof(struct ost_lvb, lvb_ctime) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct ost_lvb, lvb_ctime));
        LASSERTF((int)sizeof(((struct ost_lvb *)0)->lvb_ctime) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ost_lvb *)0)->lvb_ctime));
        LASSERTF((int)offsetof(struct ost_lvb, lvb_blocks) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct ost_lvb, lvb_blocks));
        LASSERTF((int)sizeof(((struct ost_lvb *)0)->lvb_blocks) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ost_lvb *)0)->lvb_blocks));

        /* Checks for struct ptlbd_op */
        LASSERTF((int)sizeof(struct ptlbd_op) == 12, " found %lld\n",
                 (long long)(int)sizeof(struct ptlbd_op));
        LASSERTF((int)offsetof(struct ptlbd_op, op_cmd) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_op, op_cmd));
        LASSERTF((int)sizeof(((struct ptlbd_op *)0)->op_cmd) == 2, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_op *)0)->op_cmd));
        LASSERTF((int)offsetof(struct ptlbd_op, op_lun) == 2, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_op, op_lun));
        LASSERTF((int)sizeof(((struct ptlbd_op *)0)->op_lun) == 2, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_op *)0)->op_lun));
        LASSERTF((int)offsetof(struct ptlbd_op, op_niob_cnt) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_op, op_niob_cnt));
        LASSERTF((int)sizeof(((struct ptlbd_op *)0)->op_niob_cnt) == 2, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_op *)0)->op_niob_cnt));
        LASSERTF((int)offsetof(struct ptlbd_op, op__padding) == 6, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_op, op__padding));
        LASSERTF((int)sizeof(((struct ptlbd_op *)0)->op__padding) == 2, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_op *)0)->op__padding));
        LASSERTF((int)offsetof(struct ptlbd_op, op_block_cnt) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_op, op_block_cnt));
        LASSERTF((int)sizeof(((struct ptlbd_op *)0)->op_block_cnt) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_op *)0)->op_block_cnt));

        /* Checks for struct ptlbd_niob */
        LASSERTF((int)sizeof(struct ptlbd_niob) == 24, " found %lld\n",
                 (long long)(int)sizeof(struct ptlbd_niob));
        LASSERTF((int)offsetof(struct ptlbd_niob, n_xid) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_niob, n_xid));
        LASSERTF((int)sizeof(((struct ptlbd_niob *)0)->n_xid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_niob *)0)->n_xid));
        LASSERTF((int)offsetof(struct ptlbd_niob, n_block_nr) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_niob, n_block_nr));
        LASSERTF((int)sizeof(((struct ptlbd_niob *)0)->n_block_nr) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_niob *)0)->n_block_nr));
        LASSERTF((int)offsetof(struct ptlbd_niob, n_offset) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_niob, n_offset));
        LASSERTF((int)sizeof(((struct ptlbd_niob *)0)->n_offset) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_niob *)0)->n_offset));
        LASSERTF((int)offsetof(struct ptlbd_niob, n_length) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_niob, n_length));
        LASSERTF((int)sizeof(((struct ptlbd_niob *)0)->n_length) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_niob *)0)->n_length));

        /* Checks for struct ptlbd_rsp */
        LASSERTF((int)sizeof(struct ptlbd_rsp) == 4, " found %lld\n",
                 (long long)(int)sizeof(struct ptlbd_rsp));
        LASSERTF((int)offsetof(struct ptlbd_rsp, r_status) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_rsp, r_status));
        LASSERTF((int)sizeof(((struct ptlbd_rsp *)0)->r_status) == 2, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_rsp *)0)->r_status));
        LASSERTF((int)offsetof(struct ptlbd_rsp, r_error_cnt) == 2, " found %lld\n",
                 (long long)(int)offsetof(struct ptlbd_rsp, r_error_cnt));
        LASSERTF((int)sizeof(((struct ptlbd_rsp *)0)->r_error_cnt) == 2, " found %lld\n",
                 (long long)(int)sizeof(((struct ptlbd_rsp *)0)->r_error_cnt));

        /* Checks for struct llog_logid */
        LASSERTF((int)sizeof(struct llog_logid) == 20, " found %lld\n",
                 (long long)(int)sizeof(struct llog_logid));
        LASSERTF((int)offsetof(struct llog_logid, lgl_oid) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_logid, lgl_oid));
        LASSERTF((int)sizeof(((struct llog_logid *)0)->lgl_oid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_logid *)0)->lgl_oid));
        LASSERTF((int)offsetof(struct llog_logid, lgl_ogr) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct llog_logid, lgl_ogr));
        LASSERTF((int)sizeof(((struct llog_logid *)0)->lgl_ogr) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_logid *)0)->lgl_ogr));
        LASSERTF((int)offsetof(struct llog_logid, lgl_ogen) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_logid, lgl_ogen));
        LASSERTF((int)sizeof(((struct llog_logid *)0)->lgl_ogen) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_logid *)0)->lgl_ogen));
        LASSERTF(OST_SZ_REC == 274730752, " found %lld\n",
                 (long long)OST_SZ_REC);
        LASSERTF(OST_RAID1_REC == 274731008, " found %lld\n",
                 (long long)OST_RAID1_REC);
        LASSERTF(MDS_UNLINK_REC == 274801668, " found %lld\n",
                 (long long)MDS_UNLINK_REC);
        LASSERTF(OBD_CFG_REC == 274857984, " found %lld\n",
                 (long long)OBD_CFG_REC);
        LASSERTF(PTL_CFG_REC == 274923520, " found %lld\n",
                 (long long)PTL_CFG_REC);
        LASSERTF(LLOG_GEN_REC == 274989056, " found %lld\n",
                 (long long)LLOG_GEN_REC);
        LASSERTF(LLOG_HDR_MAGIC == 275010873, " found %lld\n",
                 (long long)LLOG_HDR_MAGIC);
        LASSERTF(LLOG_LOGID_MAGIC == 275010875, " found %lld\n",
                 (long long)LLOG_LOGID_MAGIC);

        /* Checks for struct llog_catid */
        LASSERTF((int)sizeof(struct llog_catid) == 32, " found %lld\n",
                 (long long)(int)sizeof(struct llog_catid));
        LASSERTF((int)offsetof(struct llog_catid, lci_logid) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_catid, lci_logid));
        LASSERTF((int)sizeof(((struct llog_catid *)0)->lci_logid) == 20, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_catid *)0)->lci_logid));

        /* Checks for struct llog_rec_hdr */
        LASSERTF((int)sizeof(struct llog_rec_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(struct llog_rec_hdr));
        LASSERTF((int)offsetof(struct llog_rec_hdr, lrh_len) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_rec_hdr, lrh_len));
        LASSERTF((int)sizeof(((struct llog_rec_hdr *)0)->lrh_len) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_rec_hdr *)0)->lrh_len));
        LASSERTF((int)offsetof(struct llog_rec_hdr, lrh_index) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct llog_rec_hdr, lrh_index));
        LASSERTF((int)sizeof(((struct llog_rec_hdr *)0)->lrh_index) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_rec_hdr *)0)->lrh_index));
        LASSERTF((int)offsetof(struct llog_rec_hdr, lrh_type) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct llog_rec_hdr, lrh_type));
        LASSERTF((int)sizeof(((struct llog_rec_hdr *)0)->lrh_type) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_rec_hdr *)0)->lrh_type));

        /* Checks for struct llog_rec_tail */
        LASSERTF((int)sizeof(struct llog_rec_tail) == 8, " found %lld\n",
                 (long long)(int)sizeof(struct llog_rec_tail));
        LASSERTF((int)offsetof(struct llog_rec_tail, lrt_len) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_rec_tail, lrt_len));
        LASSERTF((int)sizeof(((struct llog_rec_tail *)0)->lrt_len) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_rec_tail *)0)->lrt_len));
        LASSERTF((int)offsetof(struct llog_rec_tail, lrt_index) == 4, " found %lld\n",
                 (long long)(int)offsetof(struct llog_rec_tail, lrt_index));
        LASSERTF((int)sizeof(((struct llog_rec_tail *)0)->lrt_index) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_rec_tail *)0)->lrt_index));

        /* Checks for struct llog_logid_rec */
        LASSERTF((int)sizeof(struct llog_logid_rec) == 64, " found %lld\n",
                 (long long)(int)sizeof(struct llog_logid_rec));
        LASSERTF((int)offsetof(struct llog_logid_rec, lid_hdr) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_logid_rec, lid_hdr));
        LASSERTF((int)sizeof(((struct llog_logid_rec *)0)->lid_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_logid_rec *)0)->lid_hdr));
        LASSERTF((int)offsetof(struct llog_logid_rec, lid_id) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_logid_rec, lid_id));
        LASSERTF((int)sizeof(((struct llog_logid_rec *)0)->lid_id) == 20, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_logid_rec *)0)->lid_id));
        LASSERTF((int)offsetof(struct llog_logid_rec, lid_tail) == 56, " found %lld\n",
                 (long long)(int)offsetof(struct llog_logid_rec, lid_tail));
        LASSERTF((int)sizeof(((struct llog_logid_rec *)0)->lid_tail) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_logid_rec *)0)->lid_tail));

        /* Checks for struct llog_create_rec */
        LASSERTF((int)sizeof(struct llog_create_rec) == 64, " found %lld\n",
                 (long long)(int)sizeof(struct llog_create_rec));
        LASSERTF((int)offsetof(struct llog_create_rec, lcr_hdr) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_create_rec, lcr_hdr));
        LASSERTF((int)sizeof(((struct llog_create_rec *)0)->lcr_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_create_rec *)0)->lcr_hdr));
        LASSERTF((int)offsetof(struct llog_create_rec, lcr_fid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_create_rec, lcr_fid));
        LASSERTF((int)sizeof(((struct llog_create_rec *)0)->lcr_fid) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_create_rec *)0)->lcr_fid));
        LASSERTF((int)offsetof(struct llog_create_rec, lcr_oid) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct llog_create_rec, lcr_oid));
        LASSERTF((int)sizeof(((struct llog_create_rec *)0)->lcr_oid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_create_rec *)0)->lcr_oid));
        LASSERTF((int)offsetof(struct llog_create_rec, lcr_ogen) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct llog_create_rec, lcr_ogen));
        LASSERTF((int)sizeof(((struct llog_create_rec *)0)->lcr_ogen) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_create_rec *)0)->lcr_ogen));

        /* Checks for struct llog_orphan_rec */
        LASSERTF((int)sizeof(struct llog_orphan_rec) == 40, " found %lld\n",
                 (long long)(int)sizeof(struct llog_orphan_rec));
        LASSERTF((int)offsetof(struct llog_orphan_rec, lor_hdr) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_orphan_rec, lor_hdr));
        LASSERTF((int)sizeof(((struct llog_orphan_rec *)0)->lor_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_orphan_rec *)0)->lor_hdr));
        LASSERTF((int)offsetof(struct llog_orphan_rec, lor_oid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_orphan_rec, lor_oid));
        LASSERTF((int)sizeof(((struct llog_orphan_rec *)0)->lor_oid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_orphan_rec *)0)->lor_oid));
        LASSERTF((int)offsetof(struct llog_orphan_rec, lor_ogen) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct llog_orphan_rec, lor_ogen));
        LASSERTF((int)sizeof(((struct llog_orphan_rec *)0)->lor_ogen) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_orphan_rec *)0)->lor_ogen));
        LASSERTF((int)offsetof(struct llog_orphan_rec, lor_tail) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct llog_orphan_rec, lor_tail));
        LASSERTF((int)sizeof(((struct llog_orphan_rec *)0)->lor_tail) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_orphan_rec *)0)->lor_tail));

        /* Checks for struct llog_unlink_rec */
        LASSERTF((int)sizeof(struct llog_unlink_rec) == 40, " found %lld\n",
                 (long long)(int)sizeof(struct llog_unlink_rec));
        LASSERTF((int)offsetof(struct llog_unlink_rec, lur_hdr) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_unlink_rec, lur_hdr));
        LASSERTF((int)sizeof(((struct llog_unlink_rec *)0)->lur_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_unlink_rec *)0)->lur_hdr));
        LASSERTF((int)offsetof(struct llog_unlink_rec, lur_oid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_unlink_rec, lur_oid));
        LASSERTF((int)sizeof(((struct llog_unlink_rec *)0)->lur_oid) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_unlink_rec *)0)->lur_oid));
        LASSERTF((int)offsetof(struct llog_unlink_rec, lur_ogen) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct llog_unlink_rec, lur_ogen));
        LASSERTF((int)sizeof(((struct llog_unlink_rec *)0)->lur_ogen) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_unlink_rec *)0)->lur_ogen));
        LASSERTF((int)offsetof(struct llog_unlink_rec, lur_tail) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct llog_unlink_rec, lur_tail));
        LASSERTF((int)sizeof(((struct llog_unlink_rec *)0)->lur_tail) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_unlink_rec *)0)->lur_tail));

        /* Checks for struct llog_size_change_rec */
        LASSERTF((int)sizeof(struct llog_size_change_rec) == 56, " found %lld\n",
                 (long long)(int)sizeof(struct llog_size_change_rec));
        LASSERTF((int)offsetof(struct llog_size_change_rec, lsc_hdr) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_size_change_rec, lsc_hdr));
        LASSERTF((int)sizeof(((struct llog_size_change_rec *)0)->lsc_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_size_change_rec *)0)->lsc_hdr));
        LASSERTF((int)offsetof(struct llog_size_change_rec, lsc_fid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_size_change_rec, lsc_fid));
        LASSERTF((int)sizeof(((struct llog_size_change_rec *)0)->lsc_fid) == 24, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_size_change_rec *)0)->lsc_fid));
        LASSERTF((int)offsetof(struct llog_size_change_rec, lsc_io_epoch) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct llog_size_change_rec, lsc_io_epoch));
        LASSERTF((int)sizeof(((struct llog_size_change_rec *)0)->lsc_io_epoch) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_size_change_rec *)0)->lsc_io_epoch));
        LASSERTF((int)offsetof(struct llog_size_change_rec, lsc_tail) == 48, " found %lld\n",
                 (long long)(int)offsetof(struct llog_size_change_rec, lsc_tail));
        LASSERTF((int)sizeof(((struct llog_size_change_rec *)0)->lsc_tail) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_size_change_rec *)0)->lsc_tail));

        /* Checks for struct llog_gen */
        LASSERTF((int)sizeof(struct llog_gen) == 16, " found %lld\n",
                 (long long)(int)sizeof(struct llog_gen));
        LASSERTF((int)offsetof(struct llog_gen, mnt_cnt) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_gen, mnt_cnt));
        LASSERTF((int)sizeof(((struct llog_gen *)0)->mnt_cnt) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_gen *)0)->mnt_cnt));
        LASSERTF((int)offsetof(struct llog_gen, conn_cnt) == 8, " found %lld\n",
                 (long long)(int)offsetof(struct llog_gen, conn_cnt));
        LASSERTF((int)sizeof(((struct llog_gen *)0)->conn_cnt) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_gen *)0)->conn_cnt));

        /* Checks for struct llog_gen_rec */
        LASSERTF((int)sizeof(struct llog_gen_rec) == 40, " found %lld\n",
                 (long long)(int)sizeof(struct llog_gen_rec));
        LASSERTF((int)offsetof(struct llog_gen_rec, lgr_hdr) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_gen_rec, lgr_hdr));
        LASSERTF((int)sizeof(((struct llog_gen_rec *)0)->lgr_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_gen_rec *)0)->lgr_hdr));
        LASSERTF((int)offsetof(struct llog_gen_rec, lgr_gen) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_gen_rec, lgr_gen));
        LASSERTF((int)sizeof(((struct llog_gen_rec *)0)->lgr_gen) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_gen_rec *)0)->lgr_gen));
        LASSERTF((int)offsetof(struct llog_gen_rec, lgr_tail) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct llog_gen_rec, lgr_tail));
        LASSERTF((int)sizeof(((struct llog_gen_rec *)0)->lgr_tail) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_gen_rec *)0)->lgr_tail));

        /* Checks for struct llog_log_hdr */
        LASSERTF((int)sizeof(struct llog_log_hdr) == 8192, " found %lld\n",
                 (long long)(int)sizeof(struct llog_log_hdr));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_hdr) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_hdr));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_hdr) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_hdr));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_timestamp) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_timestamp));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_timestamp) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_timestamp));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_count) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_count));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_count) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_count));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_bitmap_offset) == 28, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_bitmap_offset));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_bitmap_offset) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_bitmap_offset));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_size) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_size));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_size) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_size));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_flags) == 36, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_flags));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_flags));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_cat_idx) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_cat_idx));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_cat_idx) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_cat_idx));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_tgtuuid) == 44, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_tgtuuid));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_tgtuuid) == 40, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_tgtuuid));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_bitmap) == 88, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_bitmap));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_bitmap) == 8096, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_bitmap));
        LASSERTF((int)offsetof(struct llog_log_hdr, llh_tail) == 8184, " found %lld\n",
                 (long long)(int)offsetof(struct llog_log_hdr, llh_tail));
        LASSERTF((int)sizeof(((struct llog_log_hdr *)0)->llh_tail) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_log_hdr *)0)->llh_tail));

        /* Checks for struct llog_cookie */
        LASSERTF((int)sizeof(struct llog_cookie) == 32, " found %lld\n",
                 (long long)(int)sizeof(struct llog_cookie));
        LASSERTF((int)offsetof(struct llog_cookie, lgc_lgl) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llog_cookie, lgc_lgl));
        LASSERTF((int)sizeof(((struct llog_cookie *)0)->lgc_lgl) == 20, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_cookie *)0)->lgc_lgl));
        LASSERTF((int)offsetof(struct llog_cookie, lgc_subsys) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct llog_cookie, lgc_subsys));
        LASSERTF((int)sizeof(((struct llog_cookie *)0)->lgc_subsys) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_cookie *)0)->lgc_subsys));
        LASSERTF((int)offsetof(struct llog_cookie, lgc_index) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct llog_cookie, lgc_index));
        LASSERTF((int)sizeof(((struct llog_cookie *)0)->lgc_index) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llog_cookie *)0)->lgc_index));

        /* Checks for struct llogd_body */
        LASSERTF((int)sizeof(struct llogd_body) == 48, " found %lld\n",
                 (long long)(int)sizeof(struct llogd_body));
        LASSERTF((int)offsetof(struct llogd_body, lgd_logid) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_body, lgd_logid));
        LASSERTF((int)sizeof(((struct llogd_body *)0)->lgd_logid) == 20, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_body *)0)->lgd_logid));
        LASSERTF((int)offsetof(struct llogd_body, lgd_ctxt_idx) == 20, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_body, lgd_ctxt_idx));
        LASSERTF((int)sizeof(((struct llogd_body *)0)->lgd_ctxt_idx) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_body *)0)->lgd_ctxt_idx));
        LASSERTF((int)offsetof(struct llogd_body, lgd_llh_flags) == 24, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_body, lgd_llh_flags));
        LASSERTF((int)sizeof(((struct llogd_body *)0)->lgd_llh_flags) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_body *)0)->lgd_llh_flags));
        LASSERTF((int)offsetof(struct llogd_body, lgd_index) == 28, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_body, lgd_index));
        LASSERTF((int)sizeof(((struct llogd_body *)0)->lgd_index) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_body *)0)->lgd_index));
        LASSERTF((int)offsetof(struct llogd_body, lgd_saved_index) == 32, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_body, lgd_saved_index));
        LASSERTF((int)sizeof(((struct llogd_body *)0)->lgd_saved_index) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_body *)0)->lgd_saved_index));
        LASSERTF((int)offsetof(struct llogd_body, lgd_len) == 36, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_body, lgd_len));
        LASSERTF((int)sizeof(((struct llogd_body *)0)->lgd_len) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_body *)0)->lgd_len));
        LASSERTF((int)offsetof(struct llogd_body, lgd_cur_offset) == 40, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_body, lgd_cur_offset));
        LASSERTF((int)sizeof(((struct llogd_body *)0)->lgd_cur_offset) == 8, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_body *)0)->lgd_cur_offset));
        LASSERTF(LLOG_ORIGIN_HANDLE_OPEN == 501, " found %lld\n",
                 (long long)LLOG_ORIGIN_HANDLE_OPEN);
        LASSERTF(LLOG_ORIGIN_HANDLE_NEXT_BLOCK == 502, " found %lld\n",
                 (long long)LLOG_ORIGIN_HANDLE_NEXT_BLOCK);
        LASSERTF(LLOG_ORIGIN_HANDLE_READ_HEADER == 503, " found %lld\n",
                 (long long)LLOG_ORIGIN_HANDLE_READ_HEADER);
        LASSERTF(LLOG_ORIGIN_HANDLE_WRITE_REC == 504, " found %lld\n",
                 (long long)LLOG_ORIGIN_HANDLE_WRITE_REC);
        LASSERTF(LLOG_ORIGIN_HANDLE_CLOSE == 505, " found %lld\n",
                 (long long)LLOG_ORIGIN_HANDLE_CLOSE);
        LASSERTF(LLOG_ORIGIN_CONNECT == 506, " found %lld\n",
                 (long long)LLOG_ORIGIN_CONNECT);
        LASSERTF(LLOG_CATINFO == 507, " found %lld\n",
                 (long long)LLOG_CATINFO);

        /* Checks for struct llogd_conn_body */
        LASSERTF((int)sizeof(struct llogd_conn_body) == 40, " found %lld\n",
                 (long long)(int)sizeof(struct llogd_conn_body));
        LASSERTF((int)offsetof(struct llogd_conn_body, lgdc_gen) == 0, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_conn_body, lgdc_gen));
        LASSERTF((int)sizeof(((struct llogd_conn_body *)0)->lgdc_gen) == 16, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_conn_body *)0)->lgdc_gen));
        LASSERTF((int)offsetof(struct llogd_conn_body, lgdc_logid) == 16, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_conn_body, lgdc_logid));
        LASSERTF((int)sizeof(((struct llogd_conn_body *)0)->lgdc_logid) == 20, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_conn_body *)0)->lgdc_logid));
        LASSERTF((int)offsetof(struct llogd_conn_body, lgdc_ctxt_idx) == 36, " found %lld\n",
                 (long long)(int)offsetof(struct llogd_conn_body, lgdc_ctxt_idx));
        LASSERTF((int)sizeof(((struct llogd_conn_body *)0)->lgdc_ctxt_idx) == 4, " found %lld\n",
                 (long long)(int)sizeof(((struct llogd_conn_body *)0)->lgdc_ctxt_idx));
}
